## apriltag 0.9.8

=== Makefile ===
PREFIX ?= /usr/local

CC = gcc
AR = ar

CFLAGS = -std=gnu99 -fPIC -Wall -Wno-unused-parameter -Wno-unused-function
CFLAGS += -I. -O4 -fno-strict-overflow

APRILTAG_SRCS := $(shell ls *.c common/*.c)
APRILTAG_HEADERS := $(shell ls *.h common/*.h)
APRILTAG_OBJS := $(APRILTAG_SRCS:%.c=%.o)
TARGETS := libapriltag.a libapriltag.so

.PHONY: all
all: $(TARGETS)
	@$(MAKE) -C example all

.PHONY: install
install: libapriltag.so
	@chmod +x install.sh
	@./install.sh $(PREFIX)/lib libapriltag.so
	@./install.sh $(PREFIX)/include/apriltag $(APRILTAG_HEADERS)
	@sed 's:^prefix=$$:prefix=$(PREFIX):' < apriltag.pc.in > apriltag.pc
	@./install.sh $(PREFIX)/lib/pkgconfig apriltag.pc
	@rm apriltag.pc
	@ldconfig

libapriltag.a: $(APRILTAG_OBJS)
	@echo "   [$@]"
	@$(AR) -cq $@ $(APRILTAG_OBJS)

libapriltag.so: $(APRILTAG_OBJS)
	@echo "   [$@]"
	@$(CC) -fPIC -shared -o $@ $^

%.o: %.c
	@echo "   $@"
	@$(CC) -o $@ -c $< $(CFLAGS)

.PHONY: clean
clean:
	@rm -rf *.o common/*.o $(TARGETS)
	@$(MAKE) -C example clean

=== example/Makefile ===
CC = gcc
CXX = g++

CPPFLAGS = -I..
CFLAGS = -g -std=gnu99 -Wall -Wno-unused-parameter -Wno-unused-function -O4
CXXFLAGS = -g -Wall -O4
LDFLAGS = -lpthread -lm

TARGETS := apriltag_demo opencv_demo

.PHONY: all
all: apriltag_demo

apriltag_demo: apriltag_demo.o ../libapriltag.a
	@echo "   [$@]"
	@$(CC) -o $@ $^ $(LDFLAGS)

opencv_demo: opencv_demo.o ../libapriltag.a
	@echo "   [$@]"
	@$(CXX) -o $@ $^ $(LDFLAGS) `pkg-config --libs opencv`

%.o: %.c
	@echo "   $@"
	@$(CC) -o $@ -c $< $(CFLAGS) $(CPPFLAGS)

%.o: %.cc
	@echo "   $@"
	@$(CXX) -o $@ -c $< $(CXXFLAGS) $(CPPFLAGS)

.PHONY: clean
clean:
	@rm -rf *.o $(TARGETS)

=== debian/changelog ===
apriltag (0.9.8-2) unstable; urgency=medium

  * Fixed minor bug in simple demo

 -- Dima Kogan <dkogan@debian.org>  Tue, 18 Sep 2018 10:27:24 -0700

apriltag (0.9.8-1) unstable; urgency=medium

  * Initial package release (Closes: #891601)
  
 -- Dima Kogan <dkogan@debian.org>  Sun, 26 Aug 2018 22:04:34 -0700

=== debian/control ===
Source: apriltag
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11)
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/apriltag
Vcs-Git: https://salsa.debian.org/science-team/apriltag.git
Homepage: https://april.eecs.umich.edu/software/apriltag.html

Package: libapriltag0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: AprilTags Visual Fiducial System
 AprilTag is a visual fiducial system, useful for a wide variety of tasks
 including augmented reality, robotics, and camera calibration. Targets can be
 created from an ordinary printer, and the AprilTag detection software computes
 the precise 3D position, orientation, and identity of the tags relative to the
 camera. The AprilTag library is implemented in C with no external dependencies.
 It is designed to be easily included in other applications, as well as be
 portable to embedded devices. Real-time performance can be achieved even on
 cell-phone grade processors.

Package: libapriltag-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libapriltag0 (= ${binary:Version}),
         ${misc:Depends}
Description: AprilTags Visual Fiducial System
 AprilTag is a visual fiducial system, useful for a wide variety of tasks
 including augmented reality, robotics, and camera calibration. Targets can be
 created from an ordinary printer, and the AprilTag detection software computes
 the precise 3D position, orientation, and identity of the tags relative to the
 camera. The AprilTag library is implemented in C with no external dependencies.
 It is designed to be easily included in other applications, as well as be
 portable to embedded devices. Real-time performance can be achieved even on
 cell-phone grade processors.
 .
 This package includes the development files

=== debian/watch ===
version=4

# This project has indecisive versioning: some tarballs use a date, and some use
# a version number. Currently the latest release lives in a tarball named
# apriltag-2016-12-01.tgz and this is version 0.9.8. There isn't a lot I can do
# with this, so I at least try to make it work to automatically find newer
# versions. I map 2016-12-01 to version 0.9.8; everything older to version 0 and
# everything newer to version 1000

opts=uversionmangle=s/2016-12-01/0.9.8/;s/201[0-6]-\d\d-\d\d/0/;s/\d\d\d\d-\d\d-\d\d/1000/ \
https://april.eecs.umich.edu/media/apriltag/apriltag-([\d-]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## apriltag 0.10.0

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 AR = ar
 
 CFLAGS = -std=gnu99 -fPIC -Wall -Wno-unused-parameter -Wno-unused-function
-CFLAGS += -I. -O4 -fno-strict-overflow
+CFLAGS += -I. -O3 -fno-strict-overflow
 
 APRILTAG_SRCS := $(shell ls *.c common/*.c)
 APRILTAG_HEADERS := $(shell ls *.h common/*.h)
@@ -20,9 +20,6 @@
 	@chmod +x install.sh
 	@./install.sh $(PREFIX)/lib libapriltag.so
 	@./install.sh $(PREFIX)/include/apriltag $(APRILTAG_HEADERS)
-	@sed 's:^prefix=$$:prefix=$(PREFIX):' < apriltag.pc.in > apriltag.pc
-	@./install.sh $(PREFIX)/lib/pkgconfig apriltag.pc
-	@rm apriltag.pc
 	@ldconfig
 
 libapriltag.a: $(APRILTAG_OBJS)

=== example/Makefile ===
--- 
+++ 
@@ -2,14 +2,14 @@
 CXX = g++
 
 CPPFLAGS = -I..
-CFLAGS = -g -std=gnu99 -Wall -Wno-unused-parameter -Wno-unused-function -O4
-CXXFLAGS = -g -Wall -O4
+CFLAGS = -g -std=gnu99 -Wall -Wno-unused-parameter -Wno-unused-function -O3
+CXXFLAGS = -g -Wall -O3
 LDFLAGS = -lpthread -lm
 
 TARGETS := apriltag_demo opencv_demo
 
 .PHONY: all
-all: apriltag_demo
+all: apriltag_demo opencv_demo
 
 apriltag_demo: apriltag_demo.o ../libapriltag.a
 	@echo "   [$@]"

=== debian/changelog ===
apriltag (0.10.0-6build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:30:01 +0000

apriltag (0.10.0-6) unstable; urgency=medium

  * The in-tree build uses a relative RPATH, which should make the package
    reproducible

 -- Dima Kogan <dkogan@debian.org>  Fri, 20 Dec 2019 11:01:26 -0800

apriltag (0.10.0-5) unstable; urgency=medium

  * Removed python2 dependency (Closes: #942952)

 -- Dima Kogan <dkogan@debian.org>  Tue, 19 Nov 2019 13:15:14 -0800

apriltag (0.10.0-4) unstable; urgency=medium

  * Added python interface

 -- Dima Kogan <dkogan@debian.org>  Sun, 14 Jul 2019 10:48:08 -0700

apriltag (0.10.0-3) unstable; urgency=medium

  * New detector data supports big-endian architectures

 -- Dima Kogan <dkogan@debian.org>  Fri, 08 Feb 2019 23:08:03 -0800

apriltag (0.10.0-2) unstable; urgency=medium

  * Data used by the new detectors is now read from disk at
    runtime. (Closes: #921256,#920894)

 -- Dima Kogan <dkogan@debian.org>  Sun, 03 Feb 2019 17:46:09 -0800

apriltag (0.10.0-1) unstable; urgency=medium

  * New upstream release. ABI has changed, so we distribute a new
    libapriltag package

 -- Dima Kogan <dkogan@debian.org>  Mon, 31 Dec 2018 17:08:38 -0800

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ --with python3

override_dh_python3:
	dh_numpy3
	dh_python3

# My data files are stored in little-endian order. If building for a big-endian
# arch, I flip the order before writing the data into the package
MKBIGENDIAN32 := '$$/ = undef; $$d=<>; print pack("L>*",unpack("L<*",$$d));'
MKBIGENDIAN64 := '$$/ = undef; $$d=<>; print pack("Q>*",unpack("Q<*",$$d));'

override_dh_auto_build:

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN),little)
	cp tagCircle49h12.bitx.littleendian.data     tagCircle49h12.bitx.data
	cp tagCircle49h12.bity.littleendian.data     tagCircle49h12.bity.data
	cp tagCircle49h12.codes.littleendian.data    tagCircle49h12.codes.data
	cp tagCustom48h12.bitx.littleendian.data     tagCustom48h12.bitx.data
	cp tagCustom48h12.bity.littleendian.data     tagCustom48h12.bity.data
	cp tagCustom48h12.codes.littleendian.data    tagCustom48h12.codes.data
	cp tagStandard41h12.bitx.littleendian.data   tagStandard41h12.bitx.data
	cp tagStandard41h12.bity.littleendian.data   tagStandard41h12.bity.data
	cp tagStandard41h12.codes.littleendian.data  tagStandard41h12.codes.data
	cp tagStandard52h13.bitx.littleendian.data   tagStandard52h13.bitx.data
	cp tagStandard52h13.bity.littleendian.data   tagStandard52h13.bity.data
	cp tagStandard52h13.codes.littleendian.data  tagStandard52h13.codes.data
else
	perl -e $(MKBIGENDIAN64) < tagCircle49h12.codes.littleendian.data   >  tagCircle49h12.codes.data
	perl -e $(MKBIGENDIAN64) < tagCustom48h12.codes.littleendian.data   >  tagCustom48h12.codes.data
	perl -e $(MKBIGENDIAN64) < tagStandard41h12.codes.littleendian.data >  tagStandard41h12.codes.data
	perl -e $(MKBIGENDIAN64) < tagStandard52h13.codes.littleendian.data >  tagStandard52h13.codes.data

	perl -e $(MKBIGENDIAN32) < tagCircle49h12.bitx.littleendian.data    > tagCircle49h12.bitx.data
	perl -e $(MKBIGENDIAN32) < tagCircle49h12.bity.littleendian.data    > tagCircle49h12.bity.data
	perl -e $(MKBIGENDIAN32) < tagCustom48h12.bitx.littleendian.data    > tagCustom48h12.bitx.data
	perl -e $(MKBIGENDIAN32) < tagCustom48h12.bity.littleendian.data    > tagCustom48h12.bity.data
	perl -e $(MKBIGENDIAN32) < tagStandard41h12.bitx.littleendian.data  > tagStandard41h12.bitx.data
	perl -e $(MKBIGENDIAN32) < tagStandard41h12.bity.littleendian.data  > tagStandard41h12.bity.data
	perl -e $(MKBIGENDIAN32) < tagStandard52h13.bitx.littleendian.data  > tagStandard52h13.bitx.data
	perl -e $(MKBIGENDIAN32) < tagStandard52h13.bity.littleendian.data  > tagStandard52h13.bity.data

endif

	dh_auto_build

# don't compress sources in the examples
override_dh_compress:
	dh_compress -X.cc -X.c

=== debian/watch ===
version=4

# This project has indecisive versioning: some tarballs use a date, and some use
# a version number. Currently the latest release lives in a tarball named
# apriltag-2018-11-29.tgz and this is version 0.10.0. There isn't a lot I can do
# with this, so I at least try to make it work to automatically find newer
# versions. I map 2018-11-29 to version 0.10.0; everything older to version 0 and
# everything newer to version 1000

opts=uversionmangle=s/2018-11-29/0.10.0/;s/201[0-8]-\d\d-\d\d/0/;s/\d\d\d\d-\d\d-\d\d/1000/ \
https://april.eecs.umich.edu/media/apriltag/apriltag-([\d-]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## apriltag 3.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(apriltag VERSION 3.2.0 LANGUAGES C CXX)

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(ASAN "Use AddressSanitizer for debug builds to detect memory issues" OFF)

if (ASAN)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} \
        -fsanitize=address \
        -fsanitize=bool \
        -fsanitize=bounds \
        -fsanitize=enum \
        -fsanitize=float-cast-overflow \
        -fsanitize=float-divide-by-zero \
        -fsanitize=nonnull-attribute \
        -fsanitize=returns-nonnull-attribute \
        -fsanitize=signed-integer-overflow \
        -fsanitize=undefined \
        -fsanitize=vla-bound \
        -fno-sanitize=alignment \
        -fsanitize=leak \
        -fsanitize=object-size \
    ")
endif()

# Set a default build type if none was specified
set(default_build_type "Release")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE  STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS  "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

aux_source_directory(common COMMON_SRC)
set(APRILTAG_SRCS apriltag.c apriltag_pose.c apriltag_quad_thresh.c)

# Library
file(GLOB TAG_FILES ${PROJECT_SOURCE_DIR}/tag*.c)
add_library(${PROJECT_NAME} ${APRILTAG_SRCS} ${COMMON_SRC} ${TAG_FILES})

if (MSVC)
    # FindThreads will not find pthread.h with MSVC
    # winmm is necessary for __imp_timeGetTime
    find_library(PTHREAD_LIBRARIES NAMES pthreads)
    target_link_libraries(${PROJECT_NAME} ${PTHREAD_LIBRARIES} winmm)
else()
    find_package(Threads REQUIRED)
    target_link_libraries(${PROJECT_NAME} PUBLIC Threads::Threads m)
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION 3 VERSION ${PROJECT_VERSION})
set_target_properties(${PROJECT_NAME} PROPERTIES DEBUG_POSTFIX "d")

include(GNUInstallDirs)
target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/apriltag")


# install header file hierarchy
file(GLOB HEADER_FILES RELATIVE ${PROJECT_SOURCE_DIR} *.h common/*.h)
list(REMOVE_ITEM HEADER_FILES apriltag_detect.docstring.h apriltag_py_type.docstring.h)

foreach(HEADER ${HEADER_FILES})
    string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
    install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/${DIR})
endforeach()

# export library
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(config_install_dir "share/${PROJECT_NAME}/cmake")

# Include module with fuction 'write_basic_package_version_file'
include(CMakePackageConfigHelpers)

# Configure '<PROJECT-NAME>Config.cmake'
# Use variables:
#   * targets_export_name
#   * PROJECT_NAME
configure_package_config_file(
        "CMake/apriltagConfig.cmake.in"
        "${project_config}"
        INSTALL_DESTINATION "${config_install_dir}"
)

# Configure '<PROJECT-NAME>ConfigVersion.cmake'
# Note: PROJECT_VERSION is used as a VERSION
write_basic_package_version_file("${version_config}" COMPATIBILITY SameMajorVersion)


# install library
install(TARGETS ${PROJECT_NAME} EXPORT ${targets_export_name}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )

install(EXPORT ${targets_export_name}
    NAMESPACE apriltag::
    DESTINATION ${config_install_dir})

install(FILES ${project_config} ${version_config} DESTINATION ${config_install_dir})

export(TARGETS apriltag
    NAMESPACE apriltag::
    FILE ${generated_dir}/${targets_export_name}.cmake)


# install pkgconfig related files
FILE(READ apriltag.pc.in PKGC)
STRING(REGEX REPLACE "^prefix=" "prefix=${CMAKE_INSTALL_PREFIX}" PKGC_CONF "${PKGC}" )
FILE(WRITE ${PROJECT_BINARY_DIR}/apriltag.pc ${PKGC_CONF})
install(FILES "${PROJECT_BINARY_DIR}/apriltag.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")


# Python wrapper
include(CMakeDependentOption)
cmake_dependent_option(BUILD_PYTHON_WRAPPER "Builds Python wrapper" ON BUILD_SHARED_LIBS OFF)

if(BUILD_PYTHON_WRAPPER)
    SET(Python_ADDITIONAL_VERSIONS 3)
    find_package(PythonLibs)
    execute_process(COMMAND which python3 OUTPUT_QUIET RESULT_VARIABLE Python3_NOT_FOUND)
    execute_process(COMMAND python3 -c "import numpy" RESULT_VARIABLE Numpy_NOT_FOUND)
endif(BUILD_PYTHON_WRAPPER)

if (NOT Python3_NOT_FOUND AND NOT Numpy_NOT_FOUND AND PYTHONLIBS_FOUND AND BUILD_PYTHON_WRAPPER)
    # TODO deal with both python2/3
    execute_process(COMMAND python3 ${PROJECT_SOURCE_DIR}/python_build_flags.py OUTPUT_VARIABLE PY_OUT)
    set(PY_VARS CFLAGS LDFLAGS LINKER EXT_SUFFIX)
    cmake_parse_arguments(PY "" "${PY_VARS}" "" ${PY_OUT})
    separate_arguments(PY_CFLAGS)
    separate_arguments(PY_LDFLAGS)

    foreach(X detect py_type)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/apriltag_${X}.docstring.h
        COMMAND < ${PROJECT_SOURCE_DIR}/apriltag_${X}.docstring sed 's/\"/\\\\\"/g\; s/^/\"/\; s/$$/\\\\n\"/\;' > apriltag_${X}.docstring.h
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
    endforeach()

    add_custom_command(OUTPUT apriltag_pywrap.o
        COMMAND ${CMAKE_C_COMPILER} ${PY_CFLAGS} -I${PROJECT_BINARY_DIR} -c -o apriltag_pywrap.o ${PROJECT_SOURCE_DIR}/apriltag_pywrap.c
        DEPENDS ${PROJECT_SOURCE_DIR}/apriltag_pywrap.c ${PROJECT_BINARY_DIR}/apriltag_detect.docstring.h ${PROJECT_BINARY_DIR}/apriltag_py_type.docstring.h)
    add_custom_command(OUTPUT apriltag${PY_EXT_SUFFIX}
        COMMAND ${PY_LINKER} ${PY_LDFLAGS} -Wl,-rpath,lib apriltag_pywrap.o $<TARGET_FILE:apriltag> -o apriltag${PY_EXT_SUFFIX}
        DEPENDS ${PROJECT_NAME} apriltag_pywrap.o)
    add_custom_target(apriltag_python ALL
        DEPENDS apriltag${PY_EXT_SUFFIX})

execute_process(COMMAND python3 -m site --user-site OUTPUT_VARIABLE PY_DEST)
string(STRIP ${PY_DEST} PY_DEST)
install(FILES ${PROJECT_BINARY_DIR}/apriltag${PY_EXT_SUFFIX} DESTINATION ${PY_DEST})
endif (NOT Python3_NOT_FOUND AND NOT Numpy_NOT_FOUND AND PYTHONLIBS_FOUND AND BUILD_PYTHON_WRAPPER)


# Examples
# apriltag_demo
add_executable(apriltag_demo example/apriltag_demo.c)
target_link_libraries(apriltag_demo apriltag)

# opencv_demo
find_package(OpenCV COMPONENTS core imgproc videoio highgui QUIET)
if(OpenCV_FOUND)
    add_executable(opencv_demo example/opencv_demo.cc)
    target_link_libraries(opencv_demo apriltag ${OpenCV_LIBRARIES})
    set_target_properties(opencv_demo PROPERTIES CXX_STANDARD 11)
    install(TARGETS opencv_demo RUNTIME DESTINATION bin)
else()
    message(WARNING "OpenCV not found: Not building demo")
endif(OpenCV_FOUND)

# install example programs
install(TARGETS apriltag_demo RUNTIME DESTINATION bin)

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,8 @@
 CFLAGS = -std=gnu99 -fPIC -Wall -Wno-unused-parameter -Wno-unused-function
 CFLAGS += -I. -O3 -fno-strict-overflow
 
-APRILTAG_SRCS := $(shell ls *.c common/*.c)
+#APRILTAG_SRCS := $(shell ls *.c common/*.c)
+APRILTAG_SRCS := apriltag.c apriltag_pose.c apriltag_quad_thresh.c common/g2d.c common/getopt.c common/homography.c common/image_u8.c common/image_u8x3.c common/image_u8x4.c common/matd.c common/pam.c common/pjpeg.c common/pjpeg-idct.c common/pnm.c common/string_util.c common/svd22.c common/time_util.c common/unionfind.c common/workerpool.c common/zarray.c common/zhash.c common/zmaxheap.c tag16h5.c tag25h9.c tag36h11.c tagCircle21h7.c tagCircle49h12.c tagCustom48h12.c tagStandard41h12.c tagStandard52h13.c
 APRILTAG_HEADERS := $(shell ls *.h common/*.h)
 APRILTAG_OBJS := $(APRILTAG_SRCS:%.c=%.o)
 TARGETS := libapriltag.a libapriltag.so

=== debian/changelog ===
apriltag (3.2.0-1) unstable; urgency=medium

  * New upstream release
    - New tag family: tag36h10

 -- Dima Kogan <dkogan@debian.org>  Sat, 05 Feb 2022 15:58:40 -0800

apriltag (3.1.7-1) unstable; urgency=medium

  * New upstream release

    - Mostly bug fixes
    - Two tag families have been removed because they didn't work well:
      - tagStandard25h7
      - tagStandard32h10

 -- Dima Kogan <dkogan@debian.org>  Fri, 26 Mar 2021 19:26:11 -0700

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,19 @@
 Uploaders: Dima Kogan <dkogan@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 11)
+Build-Depends: debhelper-compat (= 12),
+  chrpath,
+  python3-dev,
+  python3-numpy,
+  dh-python,
+  libfreeimage-dev,
+  cmake
 Standards-Version: 4.1.3
 Vcs-Browser: https://salsa.debian.org/science-team/apriltag
 Vcs-Git: https://salsa.debian.org/science-team/apriltag.git
 Homepage: https://april.eecs.umich.edu/software/apriltag.html
 
-Package: libapriltag0
+Package: libapriltag3
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
@@ -28,7 +34,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libapriltag0 (= ${binary:Version}),
+Depends: libapriltag3 (= ${binary:Version}),
          ${misc:Depends}
 Description: AprilTags Visual Fiducial System
  AprilTag is a visual fiducial system, useful for a wide variety of tasks
@@ -41,3 +47,37 @@
  cell-phone grade processors.
  .
  This package includes the development files
+
+Package: python3-apriltag
+Section: python
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3 (= ${binary:Version}),
+         ${python3:Depends}
+Provides: ${python3:Provides}
+Description: AprilTags Visual Fiducial System
+ AprilTag is a visual fiducial system, useful for a wide variety of tasks
+ including augmented reality, robotics, and camera calibration. Targets can be
+ created from an ordinary printer, and the AprilTag detection software computes
+ the precise 3D position, orientation, and identity of the tags relative to the
+ camera. The AprilTag library is implemented in C with no external dependencies.
+ It is designed to be easily included in other applications, as well as be
+ portable to embedded devices. Real-time performance can be achieved even on
+ cell-phone grade processors.
+ .
+ This package provides the Python3 interfaces
+
+Package: apriltag
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3 (= ${binary:Version})
+Description: AprilTags Visual Fiducial System
+ AprilTag is a visual fiducial system, useful for a wide variety of tasks
+ including augmented reality, robotics, and camera calibration. Targets can be
+ created from an ordinary printer, and the AprilTag detection software computes
+ the precise 3D position, orientation, and identity of the tags relative to the
+ camera. The AprilTag library is implemented in C with no external dependencies.
+ It is designed to be easily included in other applications, as well as be
+ portable to embedded devices. Real-time performance can be achieved even on
+ cell-phone grade processors.
+ .
+ This package provides the commandline tools

## apriltag 3.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.1)
-project(apriltag VERSION 3.2.0 LANGUAGES C CXX)
+project(apriltag VERSION 3.3.0 LANGUAGES C CXX)
 
 if(POLICY CMP0077)
     cmake_policy(SET CMP0077 NEW)
@@ -8,7 +8,7 @@
 option(ASAN "Use AddressSanitizer for debug builds to detect memory issues" OFF)
 
 if (ASAN)
-    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} \
+    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} \
         -fsanitize=address \
         -fsanitize=bool \
         -fsanitize=bounds \
@@ -40,14 +40,11 @@
 set(APRILTAG_SRCS apriltag.c apriltag_pose.c apriltag_quad_thresh.c)
 
 # Library
-file(GLOB TAG_FILES ${PROJECT_SOURCE_DIR}/tag*.c)
+file(GLOB TAG_FILES ${CMAKE_CURRENT_SOURCE_DIR}/tag*.c)
 add_library(${PROJECT_NAME} ${APRILTAG_SRCS} ${COMMON_SRC} ${TAG_FILES})
 
 if (MSVC)
-    # FindThreads will not find pthread.h with MSVC
-    # winmm is necessary for __imp_timeGetTime
-    find_library(PTHREAD_LIBRARIES NAMES pthreads)
-    target_link_libraries(${PROJECT_NAME} ${PTHREAD_LIBRARIES} winmm)
+    add_compile_definitions("_CRT_SECURE_NO_WARNINGS")
 else()
     find_package(Threads REQUIRED)
     target_link_libraries(${PROJECT_NAME} PUBLIC Threads::Threads m)
@@ -64,7 +61,7 @@
 
 
 # install header file hierarchy
-file(GLOB HEADER_FILES RELATIVE ${PROJECT_SOURCE_DIR} *.h common/*.h)
+file(GLOB HEADER_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h common/*.h)
 list(REMOVE_ITEM HEADER_FILES apriltag_detect.docstring.h apriltag_py_type.docstring.h)
 
 foreach(HEADER ${HEADER_FILES})
@@ -134,21 +131,22 @@
 
 if (NOT Python3_NOT_FOUND AND NOT Numpy_NOT_FOUND AND PYTHONLIBS_FOUND AND BUILD_PYTHON_WRAPPER)
     # TODO deal with both python2/3
-    execute_process(COMMAND python3 ${PROJECT_SOURCE_DIR}/python_build_flags.py OUTPUT_VARIABLE PY_OUT)
+    execute_process(COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/python_build_flags.py OUTPUT_VARIABLE PY_OUT)
     set(PY_VARS CFLAGS LDFLAGS LINKER EXT_SUFFIX)
     cmake_parse_arguments(PY "" "${PY_VARS}" "" ${PY_OUT})
     separate_arguments(PY_CFLAGS)
+    list(REMOVE_ITEM PY_CFLAGS -flto)
     separate_arguments(PY_LDFLAGS)
 
     foreach(X detect py_type)
     add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/apriltag_${X}.docstring.h
-        COMMAND < ${PROJECT_SOURCE_DIR}/apriltag_${X}.docstring sed 's/\"/\\\\\"/g\; s/^/\"/\; s/$$/\\\\n\"/\;' > apriltag_${X}.docstring.h
+        COMMAND < ${CMAKE_CURRENT_SOURCE_DIR}/apriltag_${X}.docstring sed 's/\"/\\\\\"/g\; s/^/\"/\; s/$$/\\\\n\"/\;' > apriltag_${X}.docstring.h
         WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
     endforeach()
 
     add_custom_command(OUTPUT apriltag_pywrap.o
-        COMMAND ${CMAKE_C_COMPILER} ${PY_CFLAGS} -I${PROJECT_BINARY_DIR} -c -o apriltag_pywrap.o ${PROJECT_SOURCE_DIR}/apriltag_pywrap.c
-        DEPENDS ${PROJECT_SOURCE_DIR}/apriltag_pywrap.c ${PROJECT_BINARY_DIR}/apriltag_detect.docstring.h ${PROJECT_BINARY_DIR}/apriltag_py_type.docstring.h)
+        COMMAND ${CMAKE_C_COMPILER} ${PY_CFLAGS} -I${PROJECT_BINARY_DIR} -c -o apriltag_pywrap.o ${CMAKE_CURRENT_SOURCE_DIR}/apriltag_pywrap.c
+        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/apriltag_pywrap.c ${PROJECT_BINARY_DIR}/apriltag_detect.docstring.h ${PROJECT_BINARY_DIR}/apriltag_py_type.docstring.h)
     add_custom_command(OUTPUT apriltag${PY_EXT_SUFFIX}
         COMMAND ${PY_LINKER} ${PY_LDFLAGS} -Wl,-rpath,lib apriltag_pywrap.o $<TARGET_FILE:apriltag> -o apriltag${PY_EXT_SUFFIX}
         DEPENDS ${PROJECT_NAME} apriltag_pywrap.o)
@@ -160,14 +158,14 @@
 install(FILES ${PROJECT_BINARY_DIR}/apriltag${PY_EXT_SUFFIX} DESTINATION ${PY_DEST})
 endif (NOT Python3_NOT_FOUND AND NOT Numpy_NOT_FOUND AND PYTHONLIBS_FOUND AND BUILD_PYTHON_WRAPPER)
 
-
 # Examples
 # apriltag_demo
 add_executable(apriltag_demo example/apriltag_demo.c)
-target_link_libraries(apriltag_demo apriltag)
+target_link_libraries(apriltag_demo ${PROJECT_NAME})
 
 # opencv_demo
-find_package(OpenCV COMPONENTS core imgproc videoio highgui QUIET)
+# NB: contrib required for TickMeter in OpenCV 2.4. This is only required for 16.04 backwards compatibility and can be removed in the future.
+find_package(OpenCV COMPONENTS core imgproc videoio highgui contrib QUIET)
 if(OpenCV_FOUND)
     add_executable(opencv_demo example/opencv_demo.cc)
     target_link_libraries(opencv_demo apriltag ${OpenCV_LIBRARIES})

=== debian/changelog ===
apriltag (3.3.0-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:40:28 +0000

apriltag (3.3.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061895

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 01:19:00 +0000

apriltag (3.3.0-2) unstable; urgency=medium

  * I ship cmake files into arch-specific directories

 -- Dima Kogan <dkogan@debian.org>  Sat, 30 Sep 2023 12:21:36 -0700

apriltag (3.3.0-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 08 Sep 2022 18:56:11 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: apriltag
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
   chrpath,
   python3-dev,
   python3-numpy,
@@ -15,7 +16,10 @@
 Vcs-Git: https://salsa.debian.org/science-team/apriltag.git
 Homepage: https://april.eecs.umich.edu/software/apriltag.html
 
-Package: libapriltag3
+Package: libapriltag3t64
+Provides: ${t64:Provides}
+Replaces: libapriltag3
+Breaks: libapriltag3 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends},
@@ -34,7 +38,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libapriltag3 (= ${binary:Version}),
+Depends: libapriltag3t64 (= ${binary:Version}),
          ${misc:Depends}
 Description: AprilTags Visual Fiducial System
  AprilTag is a visual fiducial system, useful for a wide variety of tasks
@@ -52,7 +56,7 @@
 Section: python
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3t64 (= ${binary:Version}),
          ${python3:Depends}
 Provides: ${python3:Provides}
 Description: AprilTags Visual Fiducial System
@@ -69,7 +73,7 @@
 
 Package: apriltag
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libapriltag3t64 (= ${binary:Version})
 Description: AprilTags Visual Fiducial System
  AprilTag is a visual fiducial system, useful for a wide variety of tasks
  including augmented reality, robotics, and camera calibration. Targets can be

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_python3:
	dh_numpy3
	dh_python3

override_dh_auto_install:
	dh_auto_install

	mv debian/tmp/usr/bin/simple_demo debian/tmp/usr/bin/apriltag
	rm -f debian/tmp/usr/bin/*_demo

	chrpath -d debian/tmp/usr/lib/python*/dist-packages/*

        # Some of the cmake files have architecture-specific content. So I put
        # them ALL in an arch-specific directory:
        #
        #   dima@shorty:/tmp$ diff libapriltag-dev_3.3.0-1+b1_a{md64,rmhf}/usr/share/apriltag/cmake/apriltagConfigVersion.cmake
        #   61c61
        #   < if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "" OR "8" STREQUAL "")
        #   ---
        #   > if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "" OR "4" STREQUAL "")
        #   66,67c66,67
        #   < if(NOT CMAKE_SIZEOF_VOID_P STREQUAL "8")
        #   <   math(EXPR installedBits "8 * 8")
        #   ---
        #   > if(NOT CMAKE_SIZEOF_VOID_P STREQUAL "4")
        #   >   math(EXPR installedBits "4 * 8")
        #
        #   dima@shorty:/tmp$ diff libapriltag-dev_3.3.0-1+b1_a{md64,rmhf}/usr/share/apriltag/cmake/apriltagTargets-none.cmake
        #   11c11
        #   <   IMPORTED_LOCATION_NONE "${_IMPORT_PREFIX}/lib/x86_64-linux-gnu/libapriltag.so.3.3.0"
        #   ---
        #   >   IMPORTED_LOCATION_NONE "${_IMPORT_PREFIX}/lib/arm-linux-gnueabihf/libapriltag.so.3.3.0"
        #   16c16
        #   < list(APPEND _cmake_import_check_files_for_apriltag::apriltag "${_IMPORT_PREFIX}/lib/x86_64-linux-gnu/libapriltag.so.3.3.0" )
        #   ---
        #   > list(APPEND _cmake_import_check_files_for_apriltag::apriltag "${_IMPORT_PREFIX}/lib/arm-linux-gnueabihf/libapriltag.so.3.3.0" )
        #   21c21
        #   <   IMPORTED_LOCATION_NONE "${_IMPORT_PREFIX}/lib/x86_64-linux-gnu/libapriltag-utils.so.3.3.0"
        #   ---
        #   >   IMPORTED_LOCATION_NONE "${_IMPORT_PREFIX}/lib/arm-linux-gnueabihf/libapriltag-utils.so.3.3.0"
        #   26c26
        #   < list(APPEND _cmake_import_check_files_for_apriltag::apriltag-utils "${_IMPORT_PREFIX}/lib/x86_64-linux-gnu/libapriltag-utils.so.3.3.0" )
        #   ---
        #   > list(APPEND _cmake_import_check_files_for_apriltag::apriltag-utils "${_IMPORT_PREFIX}/lib/arm-linux-gnueabihf/libapriltag-utils.so.3.3.0" )
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/apriltag/
	mv debian/tmp/usr/share/apriltag/cmake/* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/apriltag/
	rmdir debian/tmp/usr/share/apriltag/cmake

# don't compress sources in the examples
override_dh_compress:
	dh_compress -X.cc -X.c

## apriltag 3.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(apriltag VERSION 3.4.2 LANGUAGES C)

if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(BUILD_EXAMPLES "Build example executables" ON)
option(ASAN "Use AddressSanitizer for debug builds to detect memory issues" OFF)

if (ASAN)
    set(ASAN_FLAGS "\
        -fsanitize=address \
        -fsanitize=bool \
        -fsanitize=bounds \
        -fsanitize=enum \
        -fsanitize=float-cast-overflow \
        -fsanitize=float-divide-by-zero \
        -fsanitize=nonnull-attribute \
        -fsanitize=returns-nonnull-attribute \
        -fsanitize=signed-integer-overflow \
        -fsanitize=undefined \
        -fsanitize=vla-bound \
        -fno-sanitize=alignment \
        -fsanitize=leak \
        -fsanitize=object-size \
    ")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ASAN_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ASAN_FLAGS}")
endif()

# Set a default build type if none was specified
set(default_build_type "Release")

SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
    set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE  STRING "Choose the type of build." FORCE)
    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS  "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Werror)
    # add_compile_options(-Wpedantic)
    add_compile_options(-Wno-shift-negative-value)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND NOT APPLE AND NOT CMAKE_C_SIMULATE_ID MATCHES "MSVC")
    add_link_options("-Wl,-z,relro,-z,now,-z,defs")
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Clang" AND CMAKE_C_SIMULATE_ID MATCHES "MSVC")
    # error: 'strdup' is deprecated: The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name: _strdup.
    # "strdup" is standard since C23
    add_definitions(-D _CRT_NONSTDC_NO_DEPRECATE)
    # ignore "'fopen' is deprecated" and "'strncpy' is deprecated" warnings
    add_definitions(-D _CRT_SECURE_NO_WARNINGS)
endif()

aux_source_directory(common COMMON_SRC)
set(APRILTAG_SRCS apriltag.c apriltag_pose.c apriltag_quad_thresh.c)

# Library
file(GLOB TAG_FILES ${CMAKE_CURRENT_SOURCE_DIR}/tag*.c)
add_library(${PROJECT_NAME} ${APRILTAG_SRCS} ${COMMON_SRC} ${TAG_FILES})
set_property(TARGET ${PROJECT_NAME} PROPERTY POSITION_INDEPENDENT_CODE ON)

if (MSVC)
    add_compile_definitions("_CRT_SECURE_NO_WARNINGS")
else()
    find_package(Threads REQUIRED)
    target_link_libraries(${PROJECT_NAME} PUBLIC Threads::Threads)
endif()

if (UNIX)
    target_link_libraries(${PROJECT_NAME} PUBLIC m)
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION 3 VERSION ${PROJECT_VERSION})
set_target_properties(${PROJECT_NAME} PROPERTIES DEBUG_POSTFIX "d")
set_property(TARGET ${PROJECT_NAME} PROPERTY C_STANDARD 99)


include(GNUInstallDirs)
target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>/apriltag")


# install header file hierarchy
file(GLOB HEADER_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h common/*.h)
list(REMOVE_ITEM HEADER_FILES apriltag_detect.docstring.h apriltag_py_type.docstring.h)

foreach(HEADER ${HEADER_FILES})
    string(REGEX MATCH "(.*)[/\\]" DIR ${HEADER})
    install(FILES ${HEADER} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/${DIR})
endforeach()

# export library
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(targets_export_name "${PROJECT_NAME}Targets")
set(config_install_dir "share/${PROJECT_NAME}/cmake")

# Include module with fuction 'write_basic_package_version_file'
include(CMakePackageConfigHelpers)

# Configure '<PROJECT-NAME>Config.cmake'
# Use variables:
#   * targets_export_name
#   * PROJECT_NAME
configure_package_config_file(
        "CMake/apriltagConfig.cmake.in"
        "${project_config}"
        INSTALL_DESTINATION "${config_install_dir}"
)

# Configure '<PROJECT-NAME>ConfigVersion.cmake'
# Note: PROJECT_VERSION is used as a VERSION
write_basic_package_version_file("${version_config}" COMPATIBILITY SameMajorVersion)


# install library
install(TARGETS ${PROJECT_NAME} EXPORT ${targets_export_name}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        )

install(EXPORT ${targets_export_name}
    NAMESPACE apriltag::
    DESTINATION ${config_install_dir})

install(FILES ${project_config} ${version_config} DESTINATION ${config_install_dir})

export(TARGETS apriltag
    NAMESPACE apriltag::
    FILE ${generated_dir}/${targets_export_name}.cmake)


# install pkgconfig file
configure_file(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")


# Python wrapper
option(BUILD_PYTHON_WRAPPER "Builds Python wrapper" ON)

find_package(Python3 QUIET COMPONENTS Development NumPy)

if(BUILD_PYTHON_WRAPPER AND Python3_Development_FOUND AND Python3_NumPy_FOUND)

    include(CMake/vtkEncodeString.cmake)

    foreach(X IN ITEMS detect py_type)
        vtk_encode_string(
            INPUT ${CMAKE_CURRENT_SOURCE_DIR}/apriltag_${X}.docstring
            NAME apriltag_${X}_docstring
        )
    endforeach()
    add_custom_target(apriltag_py_docstrings DEPENDS
        ${PROJECT_BINARY_DIR}/apriltag_detect_docstring.h
        ${PROJECT_BINARY_DIR}/apriltag_py_type_docstring.h
    )

    # set the SOABI manually since renaming the library via OUTPUT_NAME does not work on MSVC
    set(apriltag_py_target "apriltag.${Python3_SOABI}")
    Python3_add_library(${apriltag_py_target} MODULE ${CMAKE_CURRENT_SOURCE_DIR}/apriltag_pywrap.c)
    add_dependencies(${apriltag_py_target} apriltag_py_docstrings)
    target_link_libraries(${apriltag_py_target} PRIVATE apriltag Python3::Python Python3::NumPy)
    target_include_directories(${apriltag_py_target} PRIVATE ${PROJECT_BINARY_DIR})

    set(PY_DEST ${CMAKE_INSTALL_PREFIX}/lib/python${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}/site-packages/)
    install(TARGETS ${apriltag_py_target} LIBRARY DESTINATION ${PY_DEST})
elseif(BUILD_PYTHON_WRAPPER)
    message(WARNING
        "Python bindings requested (BUILD_PYTHON_WRAPPER=ON) but Development and NumPy not found. "
        "Python bindings will not be built. Set BUILD_PYTHON_WRAPPER=OFF to silent this warnings."
     )
endif()

# Examples
if (BUILD_EXAMPLES)
    # apriltag_demo
    add_executable(apriltag_demo example/apriltag_demo.c)
    target_link_libraries(apriltag_demo ${PROJECT_NAME})

    # opencv_demo
    set(_OpenCV_REQUIRED_COMPONENTS core imgproc videoio highgui)
    find_package(OpenCV COMPONENTS ${_OpenCV_REQUIRED_COMPONENTS} QUIET CONFIG)
    if(OpenCV_FOUND)
        enable_language(CXX)
        # NB: contrib required for TickMeter in OpenCV 2.4. This is only required for 16.04 backwards compatibility and can be removed in the future.
        #     If we add it to the find_package initially, the demo won't build for newer OpenCV versions
        if(OpenCV_VERSION VERSION_LESS "3.0.0")
            list(APPEND _OpenCV_REQUIRED_COMPONENTS contrib)
            find_package(OpenCV COMPONENTS ${_OpenCV_REQUIRED_COMPONENTS} CONFIG)
        endif()

        add_executable(opencv_demo example/opencv_demo.cc)
        target_link_libraries(opencv_demo apriltag ${OpenCV_LIBRARIES})
        set_target_properties(opencv_demo PROPERTIES CXX_STANDARD 11)
        install(TARGETS opencv_demo RUNTIME DESTINATION bin)
    else()
        message(STATUS "OpenCV not found: Not building demo")
    endif(OpenCV_FOUND)

    # install example programs
    install(TARGETS apriltag_demo RUNTIME DESTINATION bin)
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
enable_testing()

add_library(getline OBJECT getline.c)

add_executable(test_detection test_detection.c)
target_link_libraries(test_detection ${PROJECT_NAME} getline)

# test images with true detection
set(TEST_IMAGE_NAMES
    "33369213973_9d9bb4cc96_c"
    "34085369442_304b6bafd9_c"
    "34139872896_defdb2f8d9_c"
)

foreach(IMG IN LISTS TEST_IMAGE_NAMES)
    add_test(NAME test_detection_${IMG}
             COMMAND $<TARGET_FILE:test_detection> data/${IMG}
             WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endforeach()

=== debian/changelog ===
apriltag (3.4.2-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Mon, 11 Nov 2024 09:13:16 -0800

apriltag (3.3.0-3) unstable; urgency=medium

  * CMake files shipped to proper directories correctly (Closes: #1069023)

 -- Dima Kogan <dkogan@debian.org>  Mon, 15 Apr 2024 09:50:36 -0700

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: apriltag
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dkogan@debian.org>
 Section: libs
 Priority: optional

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_python3:
	dh_numpy3
	dh_python3

override_dh_auto_install:
	dh_auto_install

	mv debian/tmp/usr/bin/simple_demo debian/tmp/usr/bin/apriltag
	rm -f debian/tmp/usr/bin/*_demo

	chrpath -d debian/tmp/usr/lib/python*/dist-packages/*

# don't compress sources in the examples
override_dh_compress:
	dh_compress -X.cc -X.c
